<?php
/**
 * GetPlaceholderGuide.phpphp
 * GetPlaceholderGuide controller.
 * @version    160901:1
 * @author     karminski karminski@outlook.com>
 * 
 * @changes    
 *             160901:1 INIT version.
 */

/**
 * class GetPlaceholderGuide extends BaseController
 */
class GetPlaceholderGuide extends SaltFish\BaseController{

    private $_h;
    public  $input                 = array(); // user input data

    public  $default_input_method  = '';
    public  $output_format         = '';
    public  $input_param           = array();


    /**
     * [__construct description]
     */
    public function __construct(){
        parent::__construct();
    }

    /**
     * public function setInputRules
     */
    public function setInputRules(){
        $this->default_input_method  = SaltFish\Input::METHOD_GET;
        $this->output_format         = SaltFish\Feedback::FORMAT_JSON;
        $this->input_param           = array(
            array(
                'param'     => 'src',
                'condition' => array(
                    'method'    => null,
                    'type'      => SaltFish\Input::TYPE_STRING,
                    'limit'     => array(),
                    'default'   => null,
                    'necessary' => true,
                ),
            ),
            array(
                'param'     => 'pageNum',
                'condition' => array(
                    'method'    => null,
                    'type'      => SaltFish\Input::TYPE_INT,
                    'limit'     => array(),
                    'default'   => null,
                    'necessary' => true,
                ),
            ),
            array(
                'param'     => 'pageSize',
                'condition' => array(
                    'method'    => null,
                    'type'      => SaltFish\Input::TYPE_INT,
                    'limit'     => array(),
                    'default'   => null,
                    'necessary' => true,
                ),
            ),
        );
        SaltFish\Feedback::setOutputFormat($this->output_format);
        SaltFish\Feedback::setCallback(null);
    }

    /**
     * [initDatabase description]
     * @return [type] [description]
     */
    public function initDatabase(){
//        $this->Cache          = new Cache;
        $this->PlaceholderGuideMongoDB        = new PlaceholderGuideMongoDB;
    }

    /**
     * [run description]
     * @return [type] [description]
     */
    public function run(){
        // init 
        $Log = $this->_log;

        // get user input
        $exception = array();
        $this->setInputRules();
        if(!SaltFish\Input::get($this->default_input_method, $this->input_param, $this->input, $exception)){
            $feed = SaltFish\Feedback::getFeed(FeedbackInfo::S_WRONG_INPUT, $exception, array()); 
            BaseView::renderJson($feed);
            return false;
        }

        // init request, result
        $GetGuideRequest = new GetGuideRequest($this->input);
        $GetGuideResult = new GetGuideResult;

        // init database
        $this->initDatabase();


        // sample 3, get data from mongodb
        if(!$this->PlaceholderGuideMongoDB->get($GetGuideRequest, $GetGuideResult)){
            $feed = SaltFish\Feedback::getFeed(FeedbackInfo::S_NO_RESULT, FeedbackInfo::M_NO_RESULT, array());
            BaseView::renderJson($feed);
            return false;
        }

        if(!$this->PlaceholderGuideMongoDB->count($GetGuideResult)){
            $feed = SaltFish\Feedback::getFeed(FeedbackInfo::S_NO_RESULT, FeedbackInfo::M_NO_RESULT, array());
            BaseView::renderJson($feed);
            return false;
        }

        // ok, feedback
        $feedData = array();
        $GetGuideResult->exportForFeedback($feedData);
//        var_dump($feedData);die;
        $feed = SaltFish\Feedback::getFeed(FeedbackInfo::S_OK, FeedbackInfo::M_OK, $feedData);
        BaseView::renderJson($feed);
        return true;
    }
}
    
