<?php
/**
 * UpdatePlaceholderGuide.phpphp
 * UpdatePlaceholderGuide controller.
 * @version    160901:1
 * @author     karminski karminski@outlook.com>
 * 
 * @changes    
 *             160901:1 INIT version.
 */

/**
 * class UpdatePlaceholderGuide extends BaseController
 */
class UpdatePlaceholderGuide extends SaltFish\BaseController{

    private $_h;
    public  $input                 = array(); // user input data

    public  $default_input_method  = '';
    public  $output_format         = '';
    public  $input_param           = array();


    /**
     * [__construct description]
     */
    public function __construct(){
        parent::__construct();
    }

    /**
     * public function setInputRules
     */
    public function setInputRules(){
        $this->default_input_method  = SaltFish\Input::METHOD_POST;
        $this->output_format         = SaltFish\Feedback::FORMAT_JSON;
        $this->input_param           = array(
            array(
                'param'     => 'id',
                'condition' => array(
                    'method'    => null,
                    'type'      => SaltFish\Input::TYPE_STRING,
                    'limit'     => array(),
                    'default'   => null,
                    'necessary' => true,
                ),
            ),
            array(
                'param'     => 'src',
                'condition' => array(
                    'method'    => null,
                    'type'      => SaltFish\Input::TYPE_STRING,
                    'limit'     => array(),
                    'default'   => null,
                    'necessary' => true,
                ),
            ),
            array(
                'param'     => 'content',
                'condition' => array(
                    'method'    => null,
                    'type'      => SaltFish\Input::TYPE_STRING,
                    'limit'     => array(),
                    'default'   => null,
                    'necessary' => false,
                ),
            ),
            array(
                'param'     => 'source',
                'condition' => array(
                    'method'    => null,
                    'type'      => SaltFish\Input::TYPE_STRING,
                    'limit'     => array(),
                    'default'   => null,
                    'necessary' => false,
                ),
            ),
            array(
                'param'     => 'startTime',
                'condition' => array(
                    'method'    => null,
                    'type'      => SaltFish\Input::TYPE_STRING,
                    'limit'     => array(),
                    'default'   => null,
                    'necessary' => false,
                ),
            ),
            array(
                'param'     => 'endTime',
                'condition' => array(
                    'method'    => null,
                    'type'      => SaltFish\Input::TYPE_STRING,
                    'limit'     => array(),
                    'default'   => null,
                    'necessary' => false,
                ),
            ),
        );
        SaltFish\Feedback::setOutputFormat($this->output_format);
        SaltFish\Feedback::setCallback(null);
    }

    /**
     * [initDatabase description]
     * @return [type] [description]
     */
    public function initDatabase(){
//        $this->Cache          = new Cache;
        $this->PlaceholderGuideMongoDB        = new PlaceholderGuideMongoDB;
    }

    /**
     * [run description]
     * @return [type] [description]
     */
    public function run(){
        // init
        $Log = $this->_log;

//        echo 213424;die;
        // get user input
        $exception = array();
        $this->setInputRules();
        if(!SaltFish\Input::get($this->default_input_method, $this->input_param, $this->input, $exception)){
            $feed = SaltFish\Feedback::getFeed(FeedbackInfo::S_WRONG_INPUT, $exception, array());
            BaseView::renderJson($feed);
            return false;
        }

        // init request, result
        $UpdateGuideRequest = new UpdateGuideRequest($this->input);
        $GeneralResult = new GeneralResult;


        // init database
        $this->initDatabase();



        $checkData = UpdateGuideRequest::checkTimeRepeat($UpdateGuideRequest);
        if ($checkData) {
            if ($this->PlaceholderGuideMongoDB->findByTime($checkData)) {
                $feed = SaltFish\Feedback::getFeed(FeedbackInfo::S_WRONG_TIME_REPECT, FeedbackInfo::M_WRONG_TIME_REPECT, array());
                BaseView::renderJson($feed);
                return false;
            }
        };
        // sample 4, set data to mongodb
        if(!$this->PlaceholderGuideMongoDB->update($UpdateGuideRequest)){
            $feed = SaltFish\Feedback::getFeed(FeedbackInfo::S_WRONG_EXEC_RESULT, FeedbackInfo::M_STORAGE_FAILED, array());
            BaseView::renderJson($feed);
            return false;
        }

        // ok, feedback
        $feedData = array();
        $GeneralResult->exportForFeedback($feedData);
        $feed = SaltFish\Feedback::getFeed(FeedbackInfo::S_OK, FeedbackInfo::M_OK, $feedData);
        BaseView::renderJson($feed);
        return true;
    }
}
    
