<?php
/**
 * AutoRequire.php
 * auto require lib.
 * @version    151123:3
 * @author     karminski <code.karminski@outlook.com>
 *
 * @changelogs    
 *             151123:3 CHNAGE function name.
 *             150609:2 FIX _header_array(), _header_json() require file name issue.
 *             150520:1 INIT commit.
 */

namespace SaltFish;

/**
 *   CLASS AutoRequire
 */
class AutoRequire{

    /**
     * [basedir description]
     * @param  null
     * @return string basedir
     */
    private static function basedir(){ 
        return dirname(__FILE__).'/../../';
    }

    /**
     * [classes description]
     * @param  array  $classes, required class type and name 
     * @return null
     */
    public static function classes(
        $classes = array('type' => array('name_1', 'name_2'))
    ){
        $basedir = self::basedir();
        foreach($classes as $type => $names){
            if(empty($names)) continue;
            foreach($names as $name){
                require("{$basedir}{$type}/{$name}.php");
            }
        }
    }

    /**
     * [headerArray description]
     * @param  string $name, config name
     * @return array h, in file array 
     */
    public static function headerArray($name = ''){
        $basedir = self::basedir(); 
        return require("{$basedir}h/{$name}.h.php");
    } 

    /**
     * [headerJson description]
     * @param  string $name, config name
     * @return array h, in file array 
     */
    public static function headerJson($name = ''){
        $basedir = self::basedir();
        return json_decode(require("{$basedir}h/{$name}.h.json"), true);
    }

}