<?php
/**
 * Config.php
 * For config fetch.
 * @version    151123:1
 * @author     karminski <code.karminski@outlook.com>
 *
 * @changes    
 *             151123:1 INIT commit.
 */

namespace SaltFish;

/**
 *   CLASS Config
 */
class Config{

    private static $instance;
    private        $main;
    private        $h;

    private function __construct(){

    }

    /**
     * [importMainConfig description]
     * @param  array $main, main config array 
     * @return null
     */
    public static function importMainConfig(&$main){
        $instance = self::getInstance();
        $instance->main = &$main;
    }

    /**
     * [get description]
     * @param  string $field_name, main config field name
     * @return array config
     */
    public static function get($field_name = ''){
        $instance = self::getInstance();
        return $instance->main[$field_name];
    }

    /**
     * [getHeader description]
     * @param  string $name, header file name
     * @return array h, header array
     */
    public static function getHeader($name = ''){
        $instance = self::getInstance();
        if(empty($instance->h[$name])){
            $instance->h[$name] = AutoRequire::headerArray($name);
        }
        return $instance->h[$name];
    }

    /**
     * [getInstance description]
     * @param  null
     * @return Config $instance
     */
    public static function getInstance(){
        if(empty(self::$instance)){
            self::$instance = new Config;
        }
        return self::$instance;
    }

}