<?php
/**
*   Feedback.php
*   Feedback message.
*   @version    160823:10
*   @author     karminski <code.karminski@outlook.com>
*   
*   @changelogs  
*               160823:10 CHANGE to singleton.
*               151024:9 REFACTORY.               
*               150811:8 ADD raw result format.
*               150520:7 old version.
*               
*/

namespace SaltFish;

/**
 * class Feedback
 */
class Feedback{
    
    // const
    const SIGNAL           = 's';
    const MESSAGE          = 'm';
    const DATA             = 'd';
    const M_OK             = 'ok';
    const FORMAT_RAW       = 'raw';
    const FORMAT_JSON      = 'json';
    const FORMAT_JSONP     = 'jsonp';
    const FORMAT_SERIALIZE = 'serialize';

    private static $instance;
    public         $output_format  = self::FORMAT_JSON;
    public         $callback       = '';

    public static $result_tmpl = array(
        self::SIGNAL  => false,
        self::MESSAGE => self::M_OK,
        self::DATA    => array(),
    );


    /**
     * [__construct description]
     */
    private function __construct(){
        return;
    }

    /**
     * [getInstance description]
     * @param  null
     * @return Log $instance
     */
    public static function getInstance(){
        if(empty(self::$instance)){
            self::$instance = new Feedback;
        }
        return self::$instance;
    }

    /**
     * [setOutputFormat description]
     * @param [type] $output_format [description]
     */
    public static function setOutputFormat($output_format = self::FORMAT_JSON){
        $instance = self::getInstance();
        $instance->output_format = $output_format;
        return;
    }

    /**
     * [setCallback description]
     * @param string $callback [description]
     */
    public static function setCallback($callback = ''){
        $instance = self::getInstance();
        $instance->callback = $callback;
        return;
    }

    /**
     * [resultTransfer description]
     * You can define your return format status field in here
     * @param  [type] $result [description]
     * @return [type]         [description]
     */
    private static function resultTransfer($result){
        if(is_numeric($result)) return $result;
        if(!empty($result)){
            return true;
        }else{
            return false;
        }
    }

    /**
     * [returnFromat description]
     * this method leave format param for extension on future
     * @param  [type] $data     [description]
     * @param  [type] $format   [description]
     * @param  string $callback [description]
     * @return [type]           [description]
     */
    private static function returnFromat(
        &$data, $format = self::FORMAT_JSON, $callback = ''
    ){
        if($format === self::FORMAT_JSON){
            return json_encode($data);
        }elseif($format === self::FORMAT_JSONP||!empty($callback)){
            $data = json_encode($data);
            $callback = urlencode($callback);
            return "{$callback}($data)";
        }elseif($format === self::FORMAT_SERIALIZE){
            return serialize($data);
        }elseif($format === self::FORMAT_RAW){
            return $data;
        }
    }

    /**
     * [getFeed description]
     * @param  boolean $result   [description]
     * @param  array   $message  [description]
     * @param  array   $data     [description]
     * @param  [type]  $format   [description]
     * @param  string  $callback [description]
     * @return [type]            [description]
     */
    public static function getFeed(
        $result   = false, 
        $message = array(), 
        $data    = array()
    ){
        $instance = self::getInstance();
        $result          = self::resultTransfer($result);
        $r               = self::$result_tmpl;
        $r[self::SIGNAL] = $result;
        if(!empty($message)){
            $r[self::MESSAGE] = $message;
        }
        if(!empty($data)){
            $r[self::DATA] = &$data;
        }
        return self::returnFromat($r, $instance->output_format, $instance->callback);
    }


}
