<?php
/**
 * ObjectArray.php
 * ObjectArray class, operate Object as array, implement by SPL.
 * @version    151201:1
 * @author     karminski <code.karminski@outlook.com>
 *
 * @changelogs 
 *             151201:1 INIT version.
 */

namespace SaltFish;

/**
 * abstract class ObjectArray implements ArrayAccess, Iterator
 */
abstract class ObjectArray implements ArrayAccess, Iterator{

    private $valid = false;
    private $data;


    /**
     * [__construct description]
     * @param array &$data [description]
     */
    public function __construct(&$data = array()){
        $this->import($data);
    }

    /**
     * [import description]
     * @param  array  &$data [description]
     * @return [type]        [description]
     */
    public function import(&$data = array()){
        $this->data = $data;
    }

    /**
     * [exportRaw description]
     * @param  [type] &$data [description]
     * @return [type]        [description]
     */
    public function exportRaw(&$data){
        $data = $this->data;
    }

    /**
     * [offsetSet description]
     * @param  [type] $offset [description]
     * @param  [type] $value  [description]
     * @return [type]         [description]
     */
    public function offsetSet($offset, $value){
        if(is_null($offset)){
            $this->data[] = $value; 
        }else{
            $this->data[$offset] = $value;
        }
    }

    /**
     * [offsetExists description]
     * @param  [type] $offset [description]
     * @return [type]         [description]
     */
    public function offsetExists($offset){
        return isset($this->data[$offset]);
    }

    /**
     * [offsetUnset description]
     * @param  [type] $offset [description]
     * @return [type]         [description]
     */
    public function offsetUnset($offset){
        unset($this->data[$offset]);
    }

    /**
     * [offsetGet description]
     * @param  [type] $offset [description]
     * @return [type]         [description]
     */
    public function offsetGet($offset){
        return isset($this->data[$offset]) ? $this->data[$offset] : null; 
    }
    
    /**
     * [rewind description]
     * @return [type] [description]
     */
    public function rewind(){
        $this->valid = (false !== reset($this->data));
    }

    /**
     * [current description]
     * @return [type] [description]
     */
    public function current(){
        return current($this->data);
    }

    /**
     * [key description]
     * @return [type] [description]
     */
    public function key(){
        return key($this->data);
    }

    /**
     * [next description]
     * @return function [description]
     */
    public function next(){
        $this->valid = (false !== next($this->data));
    }

    /**
     * [valid description]
     * @return [type] [description]
     */
    public function valid(){
        return $this->valid;
    } 

}