<?php
/**
* RedisFactory.php
* Redis connection factory.
* @version    151025:1
* @author     karminski <code.karminski@outlook.com>
*
* @changelogs
*             151025:1 INIT version.
*/

namespace SaltFish;

/**
 * class RedisFactory 
 */
class RedisFactory{

    private static $instance;
    public         $h;
    public         $pool = array();


    /**
     * [__construct description]
     * @param array &$h, redis all config
     */
    private function __construct(){
        $this->h = Config::get('cache');
        return;
    }

    /**
     * [getInstance description]
     * @return [type] [description]
     */
    public static function getInstance(){
        if(empty(self::$instance)){
            self::$instance = new RedisFactory;
        }
        return self::$instance;
    }

    /**
     * [spawn description]
     * @param  string $name, redis instance name
     * @return RedisProxy RedisProxy
     */
    public static function &spawn($name){
        $instance = self::getInstance();
        // if alerady spawn return pool result
        if(!empty($instance->pool[$name])) return $instance->pool[$name];
        // spawn
        $instance->pool[$name] = new RedisProxy($instance->h[$name]);
        return $instance->pool[$name];
    }


}