<?php
/**
*   Curl.php
*   @version   150625:6
*   @author    karminski <code.karminski@outlook.com>
*
*   @changes 
*           150625:6  add forward option.
*           150608:5  remove singleCurl() method.
*           140809:4  FIX urlencode option value.
*           140719:3  ADD urlencode option.
*           140719:2  ADD httpRequest() method.
*           130927:1  ADD singleCurl(), httpRequestPost() method.
*/

namespace SaltFish;

/**
 *  CLASS Curl 
 */
class Curl{

    /**
     * [httpRequestPost description]
     * @param  [type] $args [description]
     * @return [type]       [description]
     */
    public static function httpRequest($args){
        // start
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_URL, $args['url']);
        // set UA
        if(!empty($args['useragent'])){
            curl_setopt($ch, CURLOPT_USERAGENT, $args['useragent']);
        }
        // set time out
        if(!empty($args['timeout'])){
            curl_setopt($ch, CURLOPT_TIMEOUT, $args['timeout']);
        }
        // set data
        if(!empty($args['data'])){
            if(!empty($args['urlencode'])){     
                $urlencode = true;
            }else{
                $urlencode = false;
            }
            curl_setopt($ch, CURLOPT_POSTFIELDS, self::formData($args['data'], $urlencode));
        }
        // set header
        if(!empty($args['host'])){
            curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                'Host: '.$args['host'],
            ));
        }
        if(!empty($args['header'])){
            curl_setopt($ch, CURLOPT_HTTPHEADER, $args['header']);
        }
        //set Cookie
        if(!empty($args['cookie'])){
           curl_setopt($ch, CURLOPT_COOKIE, $args['cookie']);
        }
        // set proxy
        if(!empty($args['proxy'])){
           curl_setopt($ch, CURLOPT_PROXY, $args['proxy']);
        }
        // set gzip
        if(!empty($args['gzip'])){
            curl_setopt($ch, CURLOPT_ENCODING , "gzip");
        }
        if(!empty($args['forward'])){
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
        }
        $result = curl_exec($ch);
        $info   = curl_getinfo($ch); 
        // var_dump($info);
        unset($ch);   
        return $result;
    }

    /**
     * [formData description]
     * @param  [type] $data [description]
     * @return [type]       [description]
     */
    private static function formData($data, $urlencode = false){
        if($urlencode){
            return http_build_query($data);
        }
        $str = "";
        foreach($data as $k => $v){
                $str .= "&{$k}={$v}";
        }
        return $str;
    }
}