<?php
/**
* AMQPProxy.php
* AMQP Proxy for rabbitMQ connection.
* @version    160127:1
* @author     karminski <code.karminski@outlook.com>
*
* @changelogs
*             160127:1 INIT version.
* 
*/

namespace SaltFish;


/**
*   CLASS AMQPProxy
*/
class AMQPProxy{

    public $AMQPInstance;
    public $connectInfo;
    public $connection;
    public $exchange;
    public $channel;
    public $queue;


    /**
     * [__construct description]
     * @param array &$connectInfo.
     * @return  boolean connect result.
     */
    public function __construct(&$connectInfo){
        $this->connectInfo = $connectInfo;
        return;
    }

    /**
     * [__destruct description]
     */
    public function __destruct(){
        return $this->disconnect();
    }

    /**
     * [consume description]
     * @param  [type] $callback_func [description]
     * @return [type]                [description]
     */
    public function consume($callback_func){
        $this->connect();
        $this->queue->consume($callback_func);
    }


    /**
     * [getName description]
     * @return string name
     */
    public function getName(){
        return $this->connectInfo['name'];
    }

    /**
     * [connect description]
     * @return boolean success
     */
    public function connect(){
        if(empty($this->connection)){
            // connect
            $info = &$this->connectInfo;
            $this->connection = new \AMQPConnection();
            $this->connection->setHost($info['host']);
            $this->connection->setLogin($info['user']);
            $this->connection->setPassword($info['password']);
            $this->connection->connect();
            // set channel
            $this->channel = new \AMQPChannel($this->connection);
            // set exchange
            $this->exchange = new \AMQPExchange($this->channel);
            // spawn queue
            $this->queue = new \AMQPQueue($this->channel);
            $this->queue->setName($info['routing_key']);
            $this->queue->setFlags($info['flags']);
            $this->queue->declareQueue();
            if(empty($this->queue)) return false;
        }
        return true;
    }


    /**
     * [disconnect description]
     * @return boolean result
     */
    public function disconnect(){
        if(!is_object($this->queue)) return false;
        $this->queue->cancel();
        if(!is_object($this->connection)) return false;
        $connection->disconnect();
        return true;
    }


}
