<?php
/**
*   File.class.php
*   This class inlcude some file & folder operation method.
*   WARING: This script can works on linux only.
*   @version    151231:13
*   @author     karminski <code.karminski@outlook.com>
*   
*   @changelog
*            151231:13 ADD cat().
*            151207:12 ADD openFile(), closeFile(), readByLine().
*            151207:11 ADD flush(), humanFilesize().
*            140721:10 ADD trim to loadFile() method.
*            140721:9  FIX static method declare.
*            140719:7  ADD move(), loadFile() method.
*            131117:6  FIX txtEcho '>' method should be an atomic action
*            131012:5  FIX loadFolderFilename() read . or .. issue
*            130912:4  ADD txtReadByLineNum
*                          getLineNumByContent
*            130903:3  ADD txtTail
*            130902:2  ADD txtEcho
*                          txtHead
*                          auto_warp
*            130831:1  ADD loadFolderFilename
*                          txtWrite
*
*/


namespace SaltFish;


/**
 * class File
 */
class File{

    private static $instance;
    public         $fd;

    public function __construct(){

    }

    public function __destruct(){
        $this->closeFile();   
    }

    /**
     * [getInstance description]
     * @return [type] [description]
     */
    public static function getInstance(){
        if(empty(self::$instance)){
            self::$instance = new File;
        }
        return self::$instance;
    }

    /**
    *   PUBLIC STATIC FUNCTION loadFolderFilename
    *   This method load all filenames which in target folder into an array.
    *   @param string $dir, dir path
    *   @return array $files, array which loaded filenames 
    */
    public static function loadFolderFilename($dir){
        if(empty($dir)) return false;
        $files = array();
        if($handle = opendir($dir)){
            while(false !== ($file = readdir($handle))){
                if($file === '.' || $file === '..') continue;
                $files[] = $file;
            }
            closedir($handle);
        }else{
            return false;
        }
        return $files;
    }

    /**
    *   PUBLIC STATIC FUNCTION txtWrite
    *   This method use php BIF(build in function) 'error_log' to write files.
    *   @param string $str, what you want to write
    *   @param string $file, target file loaction 
    *   @param string $auto_wrap, there's 'unix'. 'windows'('win'), 'mac', null(no-warp) offered.  
    *   @return boolean status, write status.
    */
    public static function txtWrite($str='', $file, $auto_wrap = ''){
        if(empty($file)) return false;
        self::auto_warp($str, $auto_wrap);
        return error_log($str, 3, $file);
    }

    /**
     * [txtEcho description]
     * @param  [type] $str       [description]
     * @param  string $mode      [description]
     * @param  [type] $file      [description]
     * @param  string $auto_wrap [description]
     * @return [type]            [description]
     */
    public static function txtEcho($str, $mode ='>', $file, $auto_wrap = ''){
        if(empty($file)) return false;
        self::auto_warp($str, $auto_wrap);
        $com = "echo '{$str}' ";
        if($mode === '>'){ 
            $com .= ' > ';
            $fileTmp = $file.".tmp";
            $com .= $fileTmp;
            if(exec($com) !== "") return false;
            return (exec("mv $fileTmp $file")===""?true:false);
        }elseif($mode === '>>'){
            $com .= ' >> ';
            $com .= $file;
            return (exec($com)===""?true:false);
        }
        return false;
    }

    /**
     * [txtHead description]
     * @param  [type]  $file  [description]
     * @param  integer $lines [description]
     * @param  string  $bytes [description]
     * @return [type]         [description]
     */
    public static function txtHead($file, $lines = 1, $bytes = ''){
        if(empty($file)) return false;
        $com = "head";
        if(!empty($lines)) $com .= " -n {$lines} ";
        if(!empty($bytes)) $com .= " -c {$bytes} ";
        $com .= $file;
        return exec($com);
    }

    /**
     * [txtTail description]
     * @param  [type]  $file  [description]
     * @param  integer $lines [description]
     * @param  string  $bytes [description]
     * @return [type]         [description]
     */
    public static function txtTail($file, $lines = 1, $bytes = ''){
        if(empty($file)) return false;
        $com = "tail";
        if(!empty($lines)) $com .= " -n {$lines} ";
        if(!empty($bytes)) $com .= " -c {$bytes} ";
        $com .= $file;
        return exec($com);
    }

    /**
     * [txtReadByLineNum description]
     * @param  [type] $line [description]
     * @param  [type] $file [description]
     * @return [type]       [description]
     */
    public static function txtReadByLineNum($line, $file){
        if(empty($line)||empty($file)) return false;
        return exec("sed -n {$line}p {$file}");
    }

    /**
     * [getLineNumByContent description]
     * @param  [type] $content [description]
     * @param  [type] $file    [description]
     * @return [type]          [description]
     */
    public static function getLineNumByContent($content, $file){
        if(empty($content)||empty($file)) return false;
        $lines = exec(" awk '/{$content}/ {print NR}' $file");
        return explode("\n", $lines);
    }

    /**
     * [move description]
     * @param  [type] $target [description]
     * @param  [type] $from   [description]
     * @param  [type] $to     [description]
     * @return [type]         [description]
     */
    public static function move($target, $from, $to){
        if(empty($from)||empty($to)) return false;
        exec("mv {$from}{$target} {$to}",$out, $rc);
        if($rc === 0) return true;
        return false;
    }

    /**
     * [flush description]
     * @param  [type] $target [description]
     * @return [type]         [description]
     */
    public static function flush($target){
        if(empty($target)) return false;
        exec("echo '' > {$target}",$out, $rc);
        if($rc === 0) return true;
        return false;
    }

    /**
     * [cat description]
     * @param  [type] $target [description]
     * @param  [type] $out   [description]
     * @return [type]         [description]
     */
    public static function cat($target, &$out){
        if(empty($target)) return false;
        exec("cat {$target}", $out, $rc);
        if(empty($out)) return false;
        return true;
    }

    /**
     * [loadFile description]
     * @param  [type] $file_addr [description]
     * @return [type]            [description]
     */
    public static function loadFile($file_addr, &$content, &$content_len){
        $content     = array();
        $content_len = 0;
        $requestDataHandle = @fopen($file_addr, "r");
        if($requestDataHandle){
            while(!feof($requestDataHandle)){
                $content[] = trim(fgets($requestDataHandle));
                $content_len ++;
            }
            fclose($requestDataHandle);
        }else{
            return false;
        }
        unset($requestDataHandle);
        return true;
    }

    /**
     * [openFile description]
     * @param  [type] $file [description]
     * @return [type]       [description]
     */
    public function openFile($file){
        $fd = @fopen($file, "r");
        if(!$fd) return false;
        $this->fd = $fd;
        return true;
    }

    /**
     * [closeFile description]
     * @return [type] [description]
     */
    public function closeFile(){
        if(!empty($this->df)) fclose($this->fd);
    }

    /**
     * [readByLine description]
     * @param  string  $file        [description]
     * @param  [type]  &$line       [description]
     * @param  integer $buffer_size [description]
     * @return [type]               [description]
     */
    public function readByLine(&$line, $buffer_size = 4096){
         if(!empty($this->fd) && !feof($this->fd)){
            $line = fgets($this->fd, $buffer_size);
            return true;
        }else{
            return false;
        }
    }

    /**
     * [humanFilesize description]
     * @param  [type]  $bytes    [description]
     * @param  integer $decimals [description]
     * @return [type]            [description]
     */
    public static function humanFilesize($bytes, $decimals=2){
        $sz = 'BKMGTP';
        $factor = floor((strlen($bytes) - 1) / 3);
        return sprintf("%.{$decimals}f", $bytes / pow(1024, $factor)) . @$sz[$factor];
    }

    /**
     * [auto_warp description]
     * @param  [type] $str  [description]
     * @param  string $mode [description]
     * @return [type]       [description]
     */
    private static function auto_warp(&$str, $mode =''){
        if(!empty($mode)){
            if($mode === 'unix'){
                $str .= "\n";
            }elseif($mode === 'win' || $mode === 'windows'){
                $str .= "\r\n";
            }elseif($mode === 'mac'){
                $str .= "\r";
            }
        }
    }

}