<?php
/**
 * GeneralRequest.phpp
 * GeneralRequest model.
 * @version    170424:1
 * @author     karminski <code.karminski@outlook.com>
 *
 * @changelogs 
 *             170424:1 INIT version.
 */

/**
 * class GeneralRequest
 */
class GeneralRequest extends Request{
    
    const UID_LEN    = 24;
    const PAGE_LIMIT = 10;

    public $uid;
    public $before;
    public $after;
    public $page;
    public $src;
    public $token;

    /**
     * [setRequest description]
     * @param [type] &$input [description]
     */
    public function setRequest(&$input){
        if(strlen($input)!==self::UID_LEN) return false;
        $this->uid          = $input['uid'];
        if(!empty($input['after'])){
            $this->after        = $input['after'];
        }elseif(!empty($input['before'])){
            $this->before       = $input['before'];
        }else{
            return false;
        }
        $this->page         = $input['page'];
        $this->token        = $input['token'];
        $this->src          = $input['src'];
        return true;
    }

    /**
     * [exportForAccessibilityCheck description]
     * @param  [type] &$data [description]
     * @return [type]        [description]
     */
    public function exportForAccessibilityCheck(&$data){
        $data = [
            'uid' => $this->uid,
        ];
        return true;
    }

    /**
     * [isAfterRequest description]
     * @return boolean [description]
     */
    public function isAfterRequest(){
        if(!empty($this->after)) return true;
        return false;
    }

    /**
     * [exportForSampleCacheSet description]
     * @param  [type] &$requestKey  [description]
     * @param  [type] &$requestData [description]
     * @return [type]               [description]
     */
    public function exportForSampleCacheSet(&$requestKey, &$requestData){
        $requestKey  = "uid";
        $requestData = $this->uid;
        return true;
    }

    /**
     * [exportForSampleCacheGet description]
     * @param  [type] &$requestKey [description]
     * @return [type]              [description]
     */
    public function exportForSampleCacheGet(&$requestKey){
        $requestKey = $this->uid;
        return true;
    }

    /**
     * [exportForSampleMongoDBStorageGet description]
     * @param  [type] $req [description]
     * @return [type]      [description]
     */
    public function exportForSampleMongoDBStorageGet(&$req){
        $req['uid'] = $this->uid;
        return true;
    }

    /**
     * [exportForSampleMongoDBStorageSet description]
     * @param  [type] &$data [description]
     * @return [type]        [description]
     */
    public function exportForSampleMongoDBStorageSet(&$data){
        $data['uid'] = $this->uid;
        return true;
    }
    /**
     * [getLimit description]
     * @param  [type] &$limit [description]
     * @return [type]         [description]
     */
    public function getLimit(&$limit){
        return self::PAGE_LIMIT * $this->page;
    }


}