<?php
/**
 * SetGuideRequest.php
 * SetGuideRequest model.
 * @version    170424:1
 * @author     karminski <code.karminski@outlook.com>
 *
 * @changelogs 
 *             170424:1 INIT version.
 */

/**
 * class SetGuideRequest
 */
class SetGuideRequest extends Request{

    public $startTime;
    public $endTime;

    /**
     * [setRequest description]
     * @param [type] &$input [description]
     */
    public function setRequest(&$input){
        if(!empty($input['content'])){
            $this->content        = $input['content'];
        }else{
            return false;
        }
        $this->source          = $input['source'];
        $this->startTime       = !empty($input['startTime']) ? self::strToMongoDBUtime($input['startTime']):$input['startTime'];
        $this->endTime         = !empty($input['endTime']) ? self::strToMongoDBUtime($input['endTime']):$input['endTime'];
        return true;
    }

    public function checkTimeIsset(SetGuideRequest $SetGuideRequest){
//        var_dump($SetGuideRequest);die;
        if(!empty($SetGuideRequest->startTime)){
            $this->startTime        = $SetGuideRequest->startTime;
        }else {
            return false;
        }
        if(!empty($SetGuideRequest->endTime)){
            $this->endTime        = $SetGuideRequest->endTime;
        }else{
            return false;
        }
        if ($SetGuideRequest->endTime <= $SetGuideRequest->startTime){
            return false;
        }
        return $SetGuideRequest;
    }
    /**
     * [exportForAccessibilityCheck description]
     * @param  [type] &$data [description]
     * @return [type]        [description]
     */
    public function exportForAccessibilityCheck(&$data){
        $data = [
            'uid' => $this->uid,
        ];
        return true;
    }

    private static function strToMongoDBUtime($time){
        if(empty($time)) return new MongoDB\BSON\UTCDateTime();
        return new MongoDB\BSON\UTCDateTime(strtotime($time)*1000);
    }

}