<?php
/**
 * UpdateGuideRequest.php
 * UpdateGuideRequest model.
 * @version    170424:1
 * @author     karminski <code.karminski@outlook.com>
 *
 * @changelogs 
 *             170424:1 INIT version.
 */

/**
 * class UpdateGuideRequest
 */
class UpdateGuideRequest extends Request{

    public $id;

    /**
     * [setRequest description]
     * @param [type] &$input [description]
     */
    public function setRequest(&$input){
        if(!empty($input['id'])){
            $this->id        = $input['id'];
        }else{
            return false;
        }

        if(!empty($input['content'])){
            $this->content        = $input['content'];
        }
        if(!empty($input['source'])){
            $this->source        = $input['source'];
        }
        if(!empty($input['startTime'])){
            $this->startTime        = !empty($input['startTime']) ? self::strToMongoDBUtime($input['startTime']):$input['startTime'];
        }
        if(!empty($input['endTime'])){
            $this->endTime        = !empty($input['endTime']) ? self::strToMongoDBUtime($input['endTime']):$input['endTime'];
        }
        return true;
    }

    private static function strToMongoDBUtime($time){
        if(empty($time)) return new MongoDB\BSON\UTCDateTime();
        return new MongoDB\BSON\UTCDateTime(strtotime($time)*1000);
    }

    public static function importFilterForUpdate($UpdateGuideRequest){
        return array(
            "_id" =>  new MongoDB\BSON\ObjectId($UpdateGuideRequest->id),
        );
    }
    public function checkTimeRepeat(UpdateGuideRequest $UpdateGuideRequest){
        if(!empty($UpdateGuideRequest->startTime)){
            $this->startTime        = $UpdateGuideRequest->startTime;
        }else{
            return false;
        }
        if(!empty($UpdateGuideRequest->endTime)){
            $this->endTime        = $UpdateGuideRequest->endTime;
        }else{
            return false;
        }
        if ($UpdateGuideRequest->endTime <= $UpdateGuideRequest->startTime){
            return false;
        }
        return true;
    }


    public static function importDataForUpdate($UpdateGuideRequest){
        unset($UpdateGuideRequest->id);
        if (isset($UpdateGuideRequest->startTime)){
            $start = $UpdateGuideRequest->startTime;
        }
        if (isset($UpdateGuideRequest->endTime)){
            $end = $UpdateGuideRequest->endTime;
        }
        $UpdateGuideRequest = ['$set'=>$UpdateGuideRequest];

        $UpdateGuideRequest = json_encode($UpdateGuideRequest);
        $UpdateGuideRequest = json_decode($UpdateGuideRequest,true);

        if (isset($UpdateGuideRequest['$set']['startTime'])){
            $UpdateGuideRequest['$set']['startTime'] = $start;
        }
        if (isset($UpdateGuideRequest['$set']['endTime'])){
            $UpdateGuideRequest['$set']['endTime'] = $end;
        }
        return $UpdateGuideRequest;
    }


    /**
     * [exportForAccessibilityCheck description]
     * @param  [type] &$data [description]
     * @return [type]        [description]
     */
    public function exportForAccessibilityCheck(&$data){
        $data = [
            'uid' => $this->uid,
        ];
        return true;
    }


}