<?php
/**
*   BaseRender.php
*   Base render.
*   @version    160104:1
*   @author     karminski <code.karminski@outlook.com>
*   
*   @changelogs  
*               160104:1 INIT commit
*/

namespace SaltFish;


/**
 * class BaseRender
 */
class BaseRender{

    /**
     * [fillBlank description]
     * @param  [type]  $data       [description]
     * @param  integer $max_length [description]
     * @return [type]              [description]
     */
    private static function fillBlank($data = "", $max_length = 0, $separator = false){
        $len = strlen($data);
        $fillNum = $max_length - $len;
        for($i=0;$i<$fillNum;$i++){
            if(!$separator){
                $data .= ' ';
            }else{
                $data .= '-';
            }
        }
        if($separator){
            return "+-{$data}-";
        }else{
            return "| {$data} ";
        }
    }

    /**
     * [generateGrid description]
     * @param  [type] $data [description]
     * @return [type]       [description]
     */
    public static function grid(&$r){
        $header     = "";
        $sepLine    = "";
        $content    = array();
        $maxLenStat = array();
        // stat max len
        $firstLine = true;
        foreach($r as $lineNum => $line){
            foreach($line as $key => $value){
                $len = 0;
                $len = strlen($value);
                if($firstLine){
                    $keyLen = strlen($key);
                    $keyLen > $len ? $len = $keyLen : true; 
                }
                if(empty($maxLenStat[$key])){
                    $maxLenStat[$key] = $len;
                    continue;
                }
                if($maxLenStat[$key]<$len) $maxLenStat[$key] = $len;
            }
            $firstLine = false;
        }
        // form grid
        $headerGenSwitch = true;
        foreach($r as $lineNum => $line){
            $content[$lineNum] = "";
            foreach($line as $key => $value){
                if($headerGenSwitch){
                    $header .= self::fillBlank($key, $maxLenStat[$key]);
                    $sepLine .= self::fillBlank('', $maxLenStat[$key], true);
                }
                $content[$lineNum] .= self::fillBlank($value, $maxLenStat[$key]);
            }
            $content[$lineNum] .= " |\n";
            $headerGenSwitch = false;
        }
        $header  .= " |\n";
        $sepLine .= "-+\n";
        $content = implode('', $content);
        return("{$sepLine}{$header}{$sepLine}{$content}{$sepLine}");
    }

}

