<?php
/**
* BaseView.php
* Views of Base.
* @version    150811:2
* @author     karminski <code.karminski@outlook.com>
*   
* @changelogs 150811:1 ADD renderRaw()
*             150511:1 INIT commit
*/

/**
 * class BaseView
 */
class BaseView{

    /**
     * [renderJson description]
     * @param  [type] $r [description]
     * @return [type]    [description]
     */
    public static function renderJson($r){
        header('Content-type: application/json; charset=utf-8');
        print($r);
        flush();
    }

    /**
     * [renderRaw description]
     * @param  [type] $r [description]
     * @return [type]    [description]
     */
    public static function renderRaw($r){
        var_dump($r);
        flush();
    }

    /**
     * [genBlank description]
     * @param  [type]  $data       [description]
     * @param  integer $max_length [description]
     * @return [type]              [description]
     */
    private static function genBlank($data = "", $max_length = 0, $separator = false){
        $len = strlen($data);
        $fillNum = $max_length - $len;
        for($i=0;$i<$fillNum;$i++){
            if(!$separator){
                $data .= ' ';
            }else{
                $data .= '-';
            }
        }
        if($separator){
            return "+-{$data}-";
        }else{
            return "| {$data} ";
        }
    }

    /**
     * [generateGrid description]
     * @param  [type] $data [description]
     * @return [type]       [description]
     */
    public static function generateGrid(&$r){
        $header     = "";
        $sepLine    = "";
        $content    = array();
        $maxLenStat = array();
        // stat max len
        $firstLine = true;
        foreach($r as $lineNum => $line){
            foreach($line as $key => $value){
                $len = 0;
                $len = strlen($value);
                if($firstLine){
                    $keyLen = strlen($key);
                    $keyLen > $len ? $len = $keyLen : true;
                }
                if(empty($maxLenStat[$key])){
                    $maxLenStat[$key] = $len;
                    continue;
                }
                if($maxLenStat[$key]<$len) $maxLenStat[$key] = $len;
            }
            $firstLine = false;
        }
        // form grid
        $headerGenSwitch = true;
        foreach($r as $lineNum => $line){
            $content[$lineNum] = "";
            foreach($line as $key => $value){
                if($headerGenSwitch){
                    $header .= self::genBlank($key, $maxLenStat[$key]);
                    $sepLine .= self::genBlank('', $maxLenStat[$key], true);
                }
                $content[$lineNum] .= self::genBlank($value, $maxLenStat[$key]);
            }
            $content[$lineNum] .= " |\n";
            $headerGenSwitch = false;
        }
        $header  .= " |\n";
        $sepLine .= "-+\n";
        $content = implode('', $content);
        return("{$sepLine}{$header}{$sepLine}{$content}{$sepLine}");
    }

    /**
     * [renderDumpGrid description]
     * @param  [type] $r [description]
     * @return [type]    [description]
     */
    public static function renderDumpGrid(&$r){
        echo self::generateGrid($r);
        flush();
    }
}

?>
